/*
    Copyright  1995-2001, The AROS Development Team. All rights reserved.
    $Id: gt_postfilterimsg.c,v 1.1.1.1 2005/03/15 15:54:23 laire Exp $
 
    Desc:
    Lang: english
*/
#include <proto/intuition.h>


#if 0
#define SDEBUG 1
#define DEBUG 1
#endif
#include "gadtools_intern.h"

/*********************************************************************
 
    NAME */
#include <proto/gadtools.h>
#include <intuition/intuition.h>

AROS_LH1(struct IntuiMessage *, GT_PostFilterIMsg,

         /*  SYNOPSIS */
         AROS_LHA(struct IntuiMessage *, modimsg, A1),

         /*  LOCATION */
         struct Library *, GadToolsBase, 18, GadTools)

/*  FUNCTION
	Restores an intuition message formerly changed with GT_FilterIMsg().
 
    INPUTS
	modimsg - The message returned from GT_FilterIMsg(). May be NULL.
 
    RESULT
	The original intuition message or NULL, if NULL was passed in.
 
    NOTES
 
    EXAMPLE
 
    BUGS
 
    SEE ALSO
        GT_FilterIMsg()
 
    INTERNALS
 
    HISTORY
 
***************************************************************************/
{
	AROS_LIBFUNC_INIT
	AROS_LIBBASE_EXT_DECL(struct GadToolsBase *,GadToolsBase)

	struct GT_IntuiMessage 	*gtmsg;
	struct IntuiMessage		*rc;

	D(bug("PostFilterIMsg: imsg 0x%lx\n",modimsg));

	gtmsg = (struct GT_IntuiMessage *)modimsg;
	if (gtmsg)
	{
		/* GT_FilterIMsg (which is called by GT_GetImsg)
		always returns an extended GadTools intuimsg */

		rc = gtmsg->origmsg;

		if (gtmsg->wasalloced)
		{
			D(bug("PostFilterIMsg: free allocated gtmsg 0x%lx\n",gtmsg));

			gtFreeMem(gtmsg, sizeof(struct GT_IntuiMessage));
		}
	}
	else
	{
		rc = NULL;
	}

	D(bug("PostFilterIMsg: return 0x%lx\n",rc));

	return rc;

	AROS_LIBFUNC_EXIT

} /* GT_PostFilterIMsg */
